; 09/20/2007 Changed format of error message
; 09/14/2009 Only write if have already written a cycle.
; 01/27/2010 Added checks for A on 12/20/2009.
; 06/28/2010 Added checks for A on 05/19/2010.
; 11/09/2010 Added checks for A on 10/08/2010.
; 11/17/2010 Added checks for B on 10/18/2010.

PRO read_324, packet, sat
compile_opt strictarrsubs
COMMON share1
COMMON share2
COMMON com_alph_prot
                                ; check checksum
temporary = packet.pkt
host_to_ieee, temporary
load_bytarr, temporary, bytarr
bytarr = [bytarr, packet.dat]
sum = total(bytarr)
IF sum MOD 256 NE 0 THEN BEGIN 
    printf, error_lun, timestamp, ' Error with checksum, apid 324'
ENDIF ELSE BEGIN 
    seq = fix(packet.dat[0])
    ;IF timestamp GT '2018-03-14T12:58:33.000' THEN stop
                                ; check seq
    IF (seq EQ 0 AND last_seq_324 NE 4 AND last_seq_324 NE -1) OR $
      (seq NE 0 AND last_seq_324 NE -1 AND last_seq_324 NE seq-1) THEN BEGIN 
        printf, error_lun, timestamp, ' Missing 324 packet', last_seq_324, seq
        check_seq1, back_cycles
        IF seq NE 0 THEN cycle_324_new = -1
        IF back_cycles NE -1 THEN BEGIN             
            IF array_equal(h_alpha, -1) NE 1 THEN BEGIN 
                IF wrote_324[num_cycles1-back_cycles] EQ 1 THEN BEGIN
                    printf, error_lun, timestamp, ' ', string(apid, format = '(Z)'), $
                            ' read_324: processing error'
                    suspect_324[num_cycles1-back_cycles] = 1
                ENDIF ELSE BEGIN 
                    suspect_324[num_cycles1-back_cycles] = 1
                    write_324, 0, back_cycles
                ENDELSE 
            ENDIF 
        ENDIF 
    ENDIF
    last_epoch_324 = pkt_epoch
    last_seq_324 = seq

    IF seq EQ 0 THEN BEGIN 
        error = fix(packet.dat[1+1])
        cycle_324_new = fix(packet.dat[2-1])
        IF error EQ 1 THEN printf, error_lun, timestamp, 'Error byte set in apid 324'
        error_324 = error
        IF (timestamp EQ '2010-10-08T20:58:37.563' AND sat EQ 'A')  THEN $
          write_cycle1, cycle_324_new, -1, last_epoch_324 ; miss seq 1&2
    ENDIF ELSE BEGIN 
        IF seq EQ 1 THEN BEGIN 
            schan_324 = fix(packet.dat[2-1])
            IF schan_324 EQ 255 THEN schan_324 = 0
            IF timestamp LT '2020-02-06T00:00:00.000' THEN BEGIN 
                IF (timestamp EQ '2012-12-31T00:22:41.680' AND sat EQ 'A') OR $
                  (timestamp EQ '2013-04-12T01:02:35.977' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-06-18T00:25:53.547' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-08-12T16:41:08.316' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-08-12T19:51:08.348' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-08-12T19:59:08.352' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-08-12T22:29:08.375' AND sat EQ 'B') OR $
                  (timestamp EQ '2013-12-15T05:48:07.270' AND sat EQ 'A') OR $
                  (timestamp EQ '2014-01-02T11:24:11.754' AND sat EQ 'B') OR $
                  (timestamp EQ '2014-05-31T19:45:03.465' AND sat EQ 'B') OR $
                  (timestamp EQ '2014-06-13T04:17:06.316' AND sat EQ 'B') OR $
                  (timestamp EQ '2014-06-23T20:44:40.484' AND sat EQ 'A') OR $
                  (timestamp EQ '2014-07-08T20:57:12.043' AND sat EQ 'B') OR $
                  (timestamp EQ '2014-08-02T23:05:38.063' AND sat EQ 'A') OR $
                  (timestamp EQ '2014-08-02T23:08:38.063' AND sat EQ 'A') OR $
                  (timestamp EQ '2015-12-28T07:16:20.520' AND sat EQ 'A') OR $
                  (timestamp EQ '2015-12-28T07:20:20.520' AND sat EQ 'A') OR $
                  (timestamp EQ '2015-12-28T07:28:20.520' AND sat EQ 'A') OR $
                  (timestamp EQ '2015-12-28T10:04:20.512' AND sat EQ 'A') OR $
                  (timestamp EQ '2016-04-16T07:46:13.020' AND sat EQ 'A') OR $
                  (timestamp EQ '2016-05-02T00:14:12.617' AND sat EQ 'A') OR $
                  (timestamp EQ '2016-09-20T12:48:02.117' AND sat EQ 'A') OR $
                  (timestamp EQ '2016-09-20T13:35:02.113' AND sat EQ 'A') OR $
                  (timestamp EQ '2016-09-20T13:40:02.113' AND sat EQ 'A') OR $
                  (timestamp EQ '2017-01-13T16:01:54.797' AND sat EQ 'A') OR $
                  (timestamp EQ '2017-02-14T12:01:52.965' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-01-14T07:58:35.934' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-01-14T10:48:35.922' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-01-14T10:55:35.922' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-01-14T10:58:35.918' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-01-14T11:06:35.918' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T10:30:30.605' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T11:49:30.602' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T11:59:30.602' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T12:49:30.598' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T13:11:30.598' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T13:29:30.594' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T13:39:30.594' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T20:32:30.570' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-04-28T20:34:30.570' AND sat EQ 'A') OR $
                  (timestamp EQ '2018-06-01T22:21:28.691' AND sat EQ 'A') OR $
                  (timestamp EQ '2019-02-05T00:32:05.832' AND sat EQ 'A') $
                  THEN write_cycle1, cycle_324_new, schan_324, last_epoch_324 
            ENDIF 
            IF (num_cycles1 EQ 0) THEN $
              write_cycle1, cycle_324_new, schan_324, last_epoch_324 $
                 ELSE IF (cycles1[num_cycles1-1] EQ cycle_324) THEN $
              write_cycle1, cycle_324_new, schan_324, last_epoch_324 $
                      ELSE check_cycle1, cycle_324_new, schan_324
            IF error_324 EQ 1 THEN set_error, cycle_324_new
            cycle_324 = cycle_324_new
            proton_peak_324[1] = fix(packet.dat[3+1]) ; pp
        ENDIF ELSE BEGIN                 
            IF seq EQ 2 THEN BEGIN 
                IF timestamp EQ '2010-10-18T05:35:15.672' AND sat EQ 'B' THEN $
                  write_cycle1, cycle_324_new, -1, last_epoch_324 ; miss seq 1&2
                proton_peak_324[2] = fix(packet.dat[1+1]) ; dp
                proton_peak_324[0] = fix(packet.dat[2-1]) ; ep
                array = fix(packet.dat[3+1])
                array = array XOR '1'x
                proton_peak_324[3] = array
            ENDIF 
        ENDELSE 
    ENDELSE 

                                ; get data
    first_esa = seq*4
    FOR i = 0, 3 DO BEGIN       ; 4 esa steps per packet
        FOR j = 0, 7 DO BEGIN   ; 8 pos 
            FOR k = 0, 7 DO BEGIN ; 8 defl
                index = (i*64)+(j*8)+k+4
                IF index MOD 2 EQ 0 THEN uncompress8, packet.dat[index-1], value $
                ELSE uncompress8, packet.dat[index+1], value 
                h_alpha[(first_esa+i), j, k] = value
            ENDFOR 
        ENDFOR
    ENDFOR 
    ;IF timestamp EQ '2013-01-13T23:46:40.582' THEN stop

    ; at end of cycle
    IF (timestamp EQ '2009-12-20T22:04:12.211' AND sat EQ 'A' AND seq EQ 0) OR $
      (timestamp EQ '2009-12-20T22:06:12.211' AND sat EQ 'A' AND seq EQ 3) OR $
      (timestamp EQ '2010-05-19T00:25:53.559' AND sat EQ 'A' AND seq EQ 3) $ 
      THEN BEGIN
        write_324, 0, 1
        proton_peak_324[*] = -1
        h_alpha[*, *, *] = -1
    ENDIF         
    IF seq EQ 4 THEN BEGIN 
        IF (timestamp EQ '2013-01-13T22:25:40.582' AND sat EQ 'A') $
          THEN write_cycle1, cycle_324, schan_324, pkt_epoch
        IF num_cycles1 GT 0 THEN write_324, 0, 1
        proton_peak_324[*] = -1
        h_alpha[*, *, *] = -1
    ENDIF 
    ;IF timestamp EQ '2013-01-13T23:46:40.582' THEN stop
    ;IF timestamp GE '2012-11-02T22:30:47.242' THEN stop
    ;IF suspect_324[553] EQ 1 THEN stop
ENDELSE 
END 
