; 09/20/2007 Changed format of error message
; 01/27/2010 Added checks for A on 12/20/2009.

PRO read_326, packet, sat
compile_opt strictarrsubs
COMMON share1
COMMON share2
COMMON com_alph_prot
                                ; check checksum
temporary = packet.pkt
host_to_ieee, temporary
load_bytarr, temporary, bytarr
bytarr = [bytarr, packet.dat]
sum = total(bytarr)
IF sum MOD 256 NE 0 THEN BEGIN 
    timestamp = parse_stereo_pkt(packet, /PKT_DATE, /ccsds) ; /ccsds is for anytim2utc
    printf, error_lun, timestamp, ' Error with checksum, apid 326'
ENDIF ELSE BEGIN 
    seq = fix(packet.dat[0])
    ;IF timestamp GE '2016-09-20T12:56:02.117' THEN stop
                                ; check seq
    IF (seq EQ 0 AND last_seq_326 NE 2 AND last_seq_326 NE -1) OR $
      (seq NE 0 AND last_seq_326 NE -1 AND last_seq_326 NE seq-1) THEN BEGIN 
        timestamp = parse_stereo_pkt(packet, /PKT_DATE, /ccsds) ; /ccsds is for anytim2utc
        printf, error_lun, timestamp, ' Missing 326 packet', last_seq_326, seq
        check_seq1, back_cycles
        IF seq NE 0 THEN cycle_326_new = -1
        IF back_cycles NE -1 THEN BEGIN             
            IF array_equal(heplusplus_peak, -1) NE 1 THEN BEGIN 
                IF wrote_326[num_cycles1-back_cycles] EQ 1 THEN BEGIN
                    printf, error_lun, timestamp, ' ', string(apid, format = '(Z)'), ' read_326: processing error'
                    suspect_326[num_cycles1-back_cycles] = 1
                ENDIF ELSE BEGIN 
                    suspect_326[num_cycles1-back_cycles] = 1
                    write_326, 0, back_cycles
                ENDELSE 
            ENDIF 
        ENDIF 
    ENDIF
    last_epoch_326 = pkt_epoch
    last_seq_326 = seq

    IF seq EQ 0 THEN BEGIN 
        error = fix(packet.dat[1+1])
        cycle_326_new = fix(packet.dat[2-1])
        IF error EQ 1 THEN printf, error_lun, timestamp, "Error byte set in apid 326."
        error_326 = error
    ENDIF ELSE BEGIN 
        IF seq EQ 1 THEN BEGIN 
            schan_326 = fix(packet.dat[2-1])
            IF schan_326 EQ 255 THEN schan_326 = 0
            IF (timestamp LT '2018-04-29T00:00:00.000') THEN BEGIN 
                IF ((timestamp EQ '2013-01-13T23:08:40.582' AND sat EQ 'A') OR $
                    (timestamp EQ '2013-03-04T09:05:30.988' AND sat EQ 'B') OR $
                    (timestamp EQ '2013-03-04T10:17:30.988' AND sat EQ 'B') OR $
                    (timestamp EQ '2013-03-04T10:49:30.988' AND sat EQ 'B') OR $
                    (timestamp EQ '2013-06-21T04:12:28.371' AND sat EQ 'A') OR $
                    (timestamp EQ '2013-09-08T07:26:12.402' AND sat EQ 'B') OR $
                    (timestamp EQ '2013-09-10T00:50:21.895' AND sat EQ 'A') OR $
                    (timestamp EQ '2014-05-31T19:42:03.461' AND sat EQ 'B') OR $
                    (timestamp EQ '2014-06-13T04:16:06.316' AND sat EQ 'B') OR $
                    (timestamp EQ '2014-07-08T19:45:12.031' AND sat EQ 'B') OR $
                    (timestamp EQ '2014-07-08T20:56:12.043' AND sat EQ 'B') OR $
                    (timestamp EQ '2014-07-08T22:34:12.063' AND sat EQ 'B') OR $
                    (timestamp EQ '2016-04-09T01:32:13.820' AND sat EQ 'A') OR $
                    (timestamp EQ '2016-04-16T07:25:13.020' AND sat EQ 'A') OR $
                    (timestamp EQ '2016-09-20T12:51:02.117' AND sat EQ 'A') OR $
                    (timestamp EQ '2016-09-20T13:27:02.117' AND sat EQ 'A') OR $
                    (timestamp EQ '2016-09-20T13:42:02.113' AND sat EQ 'A') OR $
                    (timestamp EQ '2017-02-14T11:29:52.969' AND sat EQ 'A') OR $
                    (timestamp EQ '2017-02-14T11:41:52.969' AND sat EQ 'A') OR $
                    (timestamp EQ '2018-04-28T12:18:30.598' AND sat EQ 'A') OR $
                    (timestamp EQ '2018-04-28T13:11:30.598' AND sat EQ 'A')) $
                   THEN write_cycle1, cycle_326_new, schan_326, last_epoch_326 ELSE $
                  IF (num_cycles1 EQ 0) THEN write_cycle1, cycle_326_new, schan_326, last_epoch_326 ELSE $
                  IF (cycles1[num_cycles1-1] EQ cycle_326) THEN write_cycle1, cycle_326_new, schan_326, last_epoch_326 $
                  ELSE check_cycle1, cycle_326_new, schan_326
            ENDIF ELSE BEGIN 
                IF (num_cycles1 EQ 0) THEN write_cycle1, cycle_326_new, schan_326, last_epoch_326 ELSE $
                  IF (cycles1[num_cycles1-1] EQ cycle_326) THEN write_cycle1, cycle_326_new, schan_326, last_epoch_326 $
                  ELSE check_cycle1, cycle_326_new, schan_326
            ENDELSE 
            IF error_326 EQ 1 THEN set_error, cycle_326_new
            cycle_326 = cycle_326_new
            alpha_peak_326[1] = fix(packet.dat[3+1]) ; pp
            IF (timestamp EQ '2012-11-02T18:25:47.242' AND sat EQ 'A') THEN $
              write_cycle1, cycle_326, schan_326, last_epoch_326
        ENDIF ELSE BEGIN                 
            IF seq EQ 2 THEN BEGIN 
                alpha_peak_326[2] = fix(packet.dat[1+1]) ; dp
                alpha_peak_326[0] = fix(packet.dat[2-1]) ; ep
                array = fix(packet.dat[3+1])
                array = array XOR '1'x
                alpha_peak_326[3] = array
            ENDIF 
        ENDELSE 
    ENDELSE 

                                ; get data
    first_esa = seq*4
    IF seq EQ 2 THEN num_rows = 2 ELSE num_rows = 4
    FOR i = 0, num_rows-1 DO BEGIN ; 4 esa steps per packet
        FOR j = 0, 7 DO BEGIN   ; 8 pos 
            FOR k = 0, 7 DO BEGIN ; 8 defl
                index = (i*64)+(j*8)+k+4
                IF index MOD 2 EQ 0 THEN uncompress8, packet.dat[index-1], value $
                ELSE uncompress8, packet.dat[index+1], value 
                heplusplus_peak[(first_esa+i), j, k] = value
            ENDFOR 
        ENDFOR
    ENDFOR 

    ; end of cycle
    IF (timestamp EQ '2009-12-20T22:07:12.207' AND sat EQ 'A' AND seq EQ 1) $
      THEN BEGIN
        write_326, 0, 1
        alpha_peak_326[*] = -1
        heplusplus_peak[*, *, *] = -1
    ENDIF 
    IF seq EQ 2 THEN BEGIN 
        write_326, 0, 1
        alpha_peak_326[*] = -1
        heplusplus_peak[*, *, *] = -1
    ENDIF 
ENDELSE 
END 
